#include 'Appevent.ch'
#include "Xbp.ch"

#define TXT_TITLE_TEST      'XbpHtmlViewer() sample'
#define TXT_MAIN_MENU       'Tests'
#define TXT_MENU_TEST1      'Incorrect behavior (and random app crash)'
#define TXT_MENU_TEST2      'Correct behavior'
#define TXT_MENU_QUIT       'Quit'

#define INCORRECT_BEHAVIOR  .F.
#define CORRECT_BEHAVIOR    .T.


****************
PROCEDURE DbeSys
****************

****************
PROCEDURE AppSys
****************
LOCAL oDlg

SET CHARSET TO ANSI

oDlg := XbpDialog():new( , , { 0, 0 }, { 790, 600 }, , .F. )
   oDlg:close   := {|a,b,obj| PostAppEvent( xbeP_Quit,,, obj ) }
   oDlg:taskList:= .T.
   oDlg:border  := XBPDLG_SIZEBORDER
   oDlg:title   := TXT_TITLE_TEST
   oDlg:drawingArea:colorBG:= XBPSYSCLR_APPWORKSPACE
   oDlg:create()

AppMenu( oDlg:menuBar() )
oDlg:setFrameState( XBPDLG_FRAMESTAT_MAXIMIZED )

SetAppWindow( oDlg )
SetAppFocus( oDlg )
RETURN

*****************************
PROCEDURE AppMenu( oMenuBar )
*****************************
LOCAL oMenu

oMenu := XbpMenu():new( oMenuBar )
   oMenu:title:= TXT_MAIN_MENU
   oMenu:create()

   oMenu:addItem( { TXT_MENU_TEST1, {|| Test( TXT_MENU_TEST1, INCORRECT_BEHAVIOR ) } } )
   oMenu:addItem( { TXT_MENU_TEST2, {|| Test( TXT_MENU_TEST2, CORRECT_BEHAVIOR   ) } } )
   oMenu:addItem( { TXT_MENU_QUIT,  {|| PostAppEvent( xbeP_Quit ) } } )
   oMenuBar:addItem( { oMenu, } )
RETURN

**************
PROCEDURE Main
**************
LOCAL nEvent, mp1, mp2, oXbp

DO WHILE nEvent <> xbeP_Quit
   nEvent := AppEvent( @mp1, @mp2, @oXbp )
   oXbp:handleEvent( nEvent, mp1, mp2 )
ENDDO
QUIT
RETURN

***********************************
PROCEDURE Test( cTitle, lBehavior )
***********************************
LOCAL aSizeDesk:= AppDesktop():currentSize()
LOCAL aSize    := { aSizeDesk[ 1 ] * 0.9, 550 }
LOCAL aPos     := { Int( ( aSizeDesk[ 1 ] - aSize[ 1 ] ) / 1.5 ), Int( ( aSizeDesk[ 2 ] - aSize[ 2 ] ) / 1.5 ) }
LOCAL nCont, oDlg, oHtml 

FOR nCont:= 1 TO 50
   oDlg := XbpDialog():new( AppDeskTop(), SetAppWindow(), aPos, aSize,, .F. )
      oDlg:title:= cTitle + ' [#' + LTrim( Str( nCont ) ) + ']'
      oDlg:drawingArea:clipChildren := .T.
      oDlg:create()

   oHtml:= XbpHTMLViewer():new():create( oDlg:drawingArea,, { 0, 0 }, oDlg:drawingArea:currentSize() )

   oDlg:setModalState( XBP_DISP_APPMODAL )
   oDlg:show()
   SetAppFocus( oDlg )

   oHtml:navigate( 'www.webs.com/themes',,, .F. )

   Sleep( 100 )

   IF lBehavior = CORRECT_BEHAVIOR
      oHtml:navigate( 'about:blank',,, .F. )
   ENDIF
   oDlg:setModalState( XBP_DISP_MODELESS )
   oDlg:destroy()
NEXT
RETURN
